require "susan_collins/deep_concern"
require "susan_collins/version"

module SusanCollins
  extend self

  def self.is_concerned!
    is_deeply_concerned!; is_very_concerned!
  end

  def self.is_concerned?
    is_deeply_concerned? && is_very_concerned?
  end

  def self.is_very_concerned!
    require "susan_collins/very_concerning"
  end

  def self.is_very_concerned?
    Module.method_defined?(:concerning)
  end

  def self.concerned?; is_concerned?; end
  def self.very_concerned?; is_very_concerned?; end
  def self.deeply_concerned?; is_deeply_concerned?; end

  class Error < StandardError; end
end

SusanCollins.is_concerned!
